
% Argentina meat data
%
%
% Modify the following filepath and then run
%
%
clc;clear;
%filepath = '/Users/malooney/Documents/MATLAB/WARP_code/Meat Demand Argentina.xls'
%
%
%
%
%
%
%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %% Import data from spreadsheet
% % Script for importing data from the following spreadsheet:
% %
% %    Workbook: C:\Users\mmakovi\Desktop\Meat Demand Argentina.xls
% %    Worksheet: Sheet1
% %
% % % To extend the code for use with different selected data or a different
% % spreadsheet, generate a function instead of a script.
% 
% % Auto-generated by MATLAB on 2018/09/17 13:08:48
% 
% %% Import the data
%[~, ~, raw] = xlsread(filepath,'Sheet1','A2:P5529');
%raw(cellfun(@(x) ~isempty(x) && isnumeric(x) && isnan(x),raw)) = {''};
  
% %% Replace non-numeric cells with NaN
%R = cellfun(@(x) ~isnumeric(x) && ~islogical(x),raw); % Find non-numeric cells
%raw(R) = {NaN}; % Replace non-numeric cells
  
% %% Create output variable
%MeatDemandArgentina = reshape([raw{:}],size(raw));
  
% % %% Clear temporary variables
%clearvars raw R filepath;








%% Import data from spreadsheet
% Script for importing data from the following spreadsheet:
%
%    Workbook: /Users/malooney/Documents/MATLAB/WARP_code/Meat Demand Argentina.xls
%    Worksheet: Sheet1
%
% Auto-generated by MATLAB on 15-Sep-2019 16:48:37

%% Setup the Import Options
opts = spreadsheetImportOptions("NumVariables", 16);

% Specify sheet and range
opts.Sheet = "Sheet1";
opts.DataRange = "A2:P5529";

% Specify column names and types
opts.VariableNames = ["HHID", "HHSIZE", "NW", "NE", "C", "INCOME", "MeatExp", "BeefP", "PorkP", "PoulP", "BeefQ", "PorkQ", "PoulQ", "BeefExp", "PorkExp", "PoulExp"];
opts.SelectedVariableNames = ["HHID", "HHSIZE", "NW", "NE", "C", "INCOME", "MeatExp", "BeefP", "PorkP", "PoulP", "BeefQ", "PorkQ", "PoulQ", "BeefExp", "PorkExp", "PoulExp"];
opts.VariableTypes = ["double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double"];

% Import the data
MeatDemandArgentina = readtable("/Users/malooney/Documents/MATLAB/WARP_code/Meat Demand Argentina.xls", opts, "UseExcel", false);

%% Convert to output type
MeatDemandArgentina = table2array(MeatDemandArgentina);

%% Clear temporary variables
clear opts



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

MeatDemandArgentina = MeatDemandArgentina(1:10,:);

% N = number of observations = number of rows
N = size(MeatDemandArgentina,1);

% Extract the columns which indicate price and quantity, and name them
BeefP = MeatDemandArgentina(:,8);
PorkP = MeatDemandArgentina(:,9);
PoultryP = MeatDemandArgentina(:,10);

BeefQ = MeatDemandArgentina(:,11);
PorkQ = MeatDemandArgentina(:,12);
PoultryQ = MeatDemandArgentina(:,13);

% We no longer need our full matrix of all data, so delete it
%clear MeatDemandArgentina;

% Create the expenditure matrix, which is P*Q for each row
% Expenditure = PQ = BeefP*BeefQ + PorkP*PorkQ + PoultryP*PoultryQ
Expenditure(1:N) = -999;
for n = 1:N
    Expenditure(n) = BeefP(n)*BeefQ(n) + PorkP(n)*PorkQ(n) + PoultryP(n)*PoultryQ(n);
end

% Now, test WARP, and store the results in a matrix
% The matrix WARP_test will store results, where cell (i,j) indicate
% whether the pairwise comparison of rows (choices) i and j passed WARP
%
% This matrix will be symmetric, so WARP_results(i,j) = WARP_results(j,i)
% The on-diagonals i.e. WARP_results(i,i) are meaningless, and will be 
% indicated with a dummy value of -999
%
% Initialize the whole results matrix to values of -999, to indicate no
% test has been done yet. 0 and 1 have specific meanings, so we do not want
% initialize to zeros.
WARP_results(1:N,1:N) = "inapplicable";

% Keep count of WARP passes and failures
WARP_passes = 0;
WARP_failures = 0;
    
% Having i go from 1 to N-1 and j go from i+1 to N results in C(N,2) tests 
% (combinations of N taken 2 at a time), and we ensure symmetry by setting
% both WARP_results(i,j) = WARP_results(j,i) equal to the appropriate value

for i = 1:N-1
   for j =i+1:N    
        PiQi = Expenditure(i);
        PjQj = Expenditure(j);
        PiQj = BeefP(i)*BeefQ(j) + PorkP(i)*PorkQ(j) + PoultryP(i)*PoultryQ(j);
        PjQi = BeefP(j)*BeefQ(i) + PorkP(j)*PorkQ(i) + PoultryP(j)*PoultryQ(i);
        
        %{
        
        The test for WARP is as follows:
        If you bought bundle i when you could have afforded j, then when
        you bought bundle j, it must have been that you could NOT afford
        bundle i anymore.
        
        Therefore:
        if PiQi >= PiQj then PjQj < PjQi
        
        but if PiQi < PiQj, then we don't need to test more
        
        So the test we ultimatelly need to perform is whether
        PiQi >= PiQj ***and*** PjQj >= PjQi
        which implies a failure of WARP
        
        %}
        
        % Diagnostic code
        %{
        disp('i = ')
        disp(i)
        disp('j = ')
        disp(j)
        disp('PiQi = ')
        disp(Expenditure(i))
        disp('PjQj = ')
        disp(Expenditure(j))
        
        disp('PiQj = ')
        disp(PiQj)
        disp('PjQi = ')
        disp(PjQi)
        %}
        
        % Diagonals (i=j) mean we are testing a good for WARP with itself,
        % which is meaningless, so mark the WARP test as "inapplicable"
        %
        % Our for-loops should not ever result in i=j, but this test is
        % included for robustness, especially if the for-loop is ever
        % changed (such as for diagnostic testing)
        if i == j
            WARP_results(i,j) = "inapplicable";
            %disp('Warp non-applicable')
        
        % If expenditure is zero, skip WARP testing
        elseif  Expenditure(i) == 0 || Expenditure(j) == 0
            WARP_results(i,j) = "zero expenditure";
            WARP_results(j,i) = "zero expenditure";
            
        % Test for failure of WARP between choices i and j
        elseif (Expenditure(i) >= PiQj) && (Expenditure(j) >= PjQi)
            WARP_results(i,j) = "WARP failure"; % indicates a WARP violation
            WARP_results(j,i) = "WARP failure"; % indicates a WARP violation
            WARP_failures = WARP_failures+1;
            %disp('Warp failed')
            
        % Else - i.e. if WARP does not fail, then WARP has passed
        else
            WARP_results(i,j) = "WARP pass"; % indicates a WARP pass
            WARP_results(j,i) = "WARP pass"; % indicates a WARP pass
            WARP_passes = WARP_passes+1;
            %disp('Warp passed')
        end
    end
end
    
clc
disp('WARP test complete.')
disp('N = ')
disp(N)
disp('Total WARP tests = passes + failure: ')
disp(WARP_passes+WARP_failures)
%{
% The following are diagnostic tests to verify that our for-loops were set
% up to run the correct number of tests.
% However, these tests assume that we DO test WARP when expenditure is
% zero. These tests are valid only if the only WARP tests we exclude are
% on-diagonals where i=j
disp('Total possible WARP tests = C(N,2) i.e. combinations of N taken 2 at a time:')
disp(nchoosek(N,2))
disp('Number of off-diagonal comparisons, inc. i vs. j and j vs i = N^2 - N = ')
disp(N*N-N)
disp('Number of off-diagonal comparisons, inc. i vs. j and j vs i = WARP tests * 2')
disp((WARP_passes+WARP_failures)*2)
disp('Check number of elements: double the number of tests plus diagonals should equal N^2')
    disp('N^2 = ')
    disp(N*N)  
    disp('Tests*2+N = ')
    disp((WARP_passes+WARP_failures)*2+N)
%}
disp('WARP passes: ')
disp(WARP_passes)
disp('WARP failures: ')
disp(WARP_failures)
pct_WARP_passes = WARP_passes/(WARP_passes + WARP_failures)*100;
pct_WARP_failures = 100-pct_WARP_passes;
disp ('Percent WARP passes: ')
disp(pct_WARP_passes)
disp ('Percent WARP failures: ')
disp(pct_WARP_failures)
% symmetric test only works if the matrix is double, single, or logical
% disp('WARP results matrix is symmetric: ')
% disp(issymmetric(WARP_results))
disp('WARP results end.')